/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Mit Okt 18 14:29:45 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBVector.h"


/* name: vec
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: generates a vectorfile
*/
int
vec ()
{
  int value;			//returnvalue
  FILE *file, *writer, *reader, *error;	//files
  char *savepath, *path;	//path
  char *filename;		//filename
  char *zeile, *savezeile;	//line
  char *zeilea, *savezeilea;	//longline
  char *name;
  char *temp;
  int band[MAXBAND], piece[MAXSEG], bandf, piecef;	//data
  int i, j, k;			//counter
  char current;			//current letter
  int read, *readp;
  int start, vector, cancel;
  long xdim;
  int vecdim;

//INIT
  value = -1;
  bandf = 0;
  piecef = 0;
  vecdim = 0;
  readp = &read;
  filename = malloc (MAXNAME * sizeof (char));
  name = malloc (MAXNAME * sizeof (char));
  temp = malloc (MAXLENLINE * sizeof (char));
  zeile = malloc (MAXLENLINE * sizeof (char));
  savezeile = malloc (MAXLENLINE * sizeof (char));
  zeilea = malloc (ALLARGS * sizeof (char));
  savezeilea = malloc (ALLARGS * sizeof (char));
  path = malloc (MAXLENLINE * sizeof (char));
  for (i = 0; i < MAXBAND; i++)
    {
      band[i] = -1;
      piece[i] = -1;
    }
  for (i = MAXBAND; i < MAXSEG; i++)
    piece[i] = -1;

  writer = stdout;
  error = stderr;
  reader = stdin;

//read arguments
  savezeilea = fgets (zeilea, ALLARGS, reader);

  current = 65;
  i = 0;
  current = zeilea[i];
  while (current != SPACE)
    {
      name[i] = current;
      i++;
      current = zeilea[i];
    }
  name[i] = '\0';		//Name in name;
  i++;				//i on first letter

  k = 0;
  current = zeilea[i];
  while (current != ASCIIS)
    {
      j = 0;
      while (current != SPACE)
	{
	  temp[j] = current;
	  j++;
	  i++;
	  current = zeilea[i];
	}
      temp[j] = ' ';		//Name in name;
      value = sscanf (temp, "%d ", readp);
      band[k] = read;
      k++;
      i++;			//i on neat number
      current = zeilea[i];
    }				//current - arguments ready
  i++;
  i++;				//i on piece

  k = 0;
  current = zeilea[i];
  while (current != NEWLINE)
    {
      j = 0;
      while ((current != SPACE) && (current != NEWLINE))
	{
	  temp[j] = current;
	  j++;
	  i++;
	  current = zeilea[i];
	}
      temp[j] = ' ';		//Name in name;
      value = sscanf (temp, "%d ", readp);
      piece[k] = read;
      k++;
      if (current != NEWLINE)
	i++;			//i on next number
      current = zeilea[i];
    }				//current - Arguments ready
  free (zeilea);
  free (savezeilea);

//read now path
  savezeile = fgets (zeile, MAXLENLINE, reader);
  strncpy (path, zeile, strlen (zeile) - 1);
  strcat (path, "/");

//begin file analysis
  cancel = FALSE;
  xdim = 0;
  while (cancel == FALSE)
    {
      savepath = malloc (MAXLENLINE * sizeof (char));
      strcpy (savepath, path);

//filename
      savezeile = fgets (zeile, MAXLENLINE, reader);

      if (savezeile == NULL)	//eof
	cancel = TRUE;

      if (cancel == FALSE)
	{
//extraktion of: name, band, piece
	  i = 0;
	  current = zeile[i];
	  while (current != ASCIIDOT)
	    {
	      filename[i] = current;
	      i++;
	      current = zeile[i];
	    }
	  filename[i] = ASCIIDOT;
	  i++;
	  current = zeile[i];
//till second dot
	  while (current != ASCIIDOT)
	    {
	      filename[i] = current;
	      i++;
	      current = zeile[i];
	    }
	  filename[i] = '\0';	//filename OK, print at the end of line

//extraction of band
//number after dot
	  start = FALSE;
	  current = zeile[i];
	  while (start != TRUE)
	    {
	      while (current != ASCIIDOT)
		{
		  i++;
		  current = zeile[i];
		}
	      i++;
	      //this should be a number
	      current = zeile[i];
	      if ((current >= ASCIIZERO) && (current <= ASCIININE)
		  && (start == 2))
		{
		  j = 0;
		  while (current != ASCIIS)
		    {
		      temp[j] = current;
		      i++;
		      j++;
		      current = zeile[i];
		    }
		  temp[j] = ' ';	//Name in name;
		  value = sscanf (temp, "%d ", readp);
		  piecef = read;	//in piecef is now the segmentnumber of the file
		  start = TRUE;
		}
	      if ((current >= ASCIIZERO) && (current <= ASCIININE)
		  && (start == FALSE))
		{
		  j = 0;
		  while (current != ASCIIDOT)
		    {
		      temp[j] = current;
		      i++;
		      j++;
		      current = zeile[i];
		    }
		  temp[j] = ' ';	//Name in name;
		  value = sscanf (temp, "%d ", readp);
		  bandf = read;	//bandf contains now wave band of files
		  start = 2;
		}
	    }
//Filename in filename, band in bandf, segnr in piecef

//do a vector?
	  vector = FALSE;
	  for (i = 0; i < MAXBAND; i++)
	    if (bandf == band[i])
	      vector = 2;

	  for (i = 0; i < MAXSEG; i++)
	    if ((piecef == piece[i]) && (vector == 2))
	      vector = TRUE;

	  if (vector == TRUE)
	    {
	      //do it!
	      strncat (savepath, zeile, strlen (zeile) - 1);
	      file = fopen (savepath, "r");

	      current = fgetc (file);
	      vecdim = 0;
	      while (current != EOF)
		{
		  fprintf (writer, "%c", current);
		  current = fgetc (file);
		  if (current == SPACE)
		    vecdim++;
		}
	      xdim++;
	      (void) fclose (file);
	      fprintf (writer, "%s.band%d.seg%d.ungew\n", filename, bandf,
		       piecef);
	    }			//if vector== true
//file done, next line
	}			//if cancel ==TRUE
      free (savepath);
    }				// while cancel

//print dim, vectim and titel to header file
  fprintf (error, "$TYPE %s\n$XDIM %ld\n$YDIM %d\n$VEC_DIM %d\n", name, xdim,
	   YDIM, vecdim);

  (void) fflush (writer);
  (void) fflush (error);
  (void) fclose (reader);
  free (path);
  free (zeile);
  free (savezeile);
  free (name);
  free (temp);

  if (value > 0)
    value = 0;
  return value;
}


/* name: main
 * var: none
 * exitcode: 0 (for normal termination - returncode)
 * explanation: calls vec
*/
int
main (int argc, char *argv[])
{
  int value = -1;

  if (argc == 1)
    value = vec ();
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return value;
}
